#!/usr/bin/perl -w
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#	this script sets the reply for "ctcp version requests" to the song
#	currently played by moc

use strict;
use Irssi;
use vars qw($VERSION %IRSSI);
$VERSION = '1.00';
%IRSSI = (
    authors     => 'Haui',
    contact     => 'haui45@web.de',
    name        => 'mocctcp',
    description => 'ctcp version reply script',
    license     => 'GPL',
);

my @array;
my %info;
my $string;
my $in;
my $foo;

sub checkplaying(){
	@array = `mocp -i`;
	foreach(@array){
		$foo = $_;
		if ($foo =~ m/^State:/){
			$foo =~ s/State: //;
			chomp($foo);
			if ($foo eq "STOP" || $foo eq "PAUSE"){
				Irssi::settings_set_str('ctcp_version_reply', "No song playing!");
				return 1;
			}
		}
	}
	return 0;
}

sub moc{
	@array = `mocp -i`;
	foreach (@array){
		if ($_ =~ m/^SongTitle:/) {$info{"title"} = $_; $info{"title"} =~ s/SongTitle: //; chomp $info{"title"}}; 
		if ($_ =~ m/^Artist/) {$info{"artist"} = $_; $info{"artist"} =~ s/Artist: //; chomp $info{"artist"}}; 
		if ($_ =~ m/^Album/) {$info{"album"} = $_; $info{"album"} =~ s/Album: //; chomp $info{"album"}}; 
		if ($_ =~ m/^TotalTime/) {$info{"total"} = $_; $info{"total"} =~ s/TotalTime: //; chomp $info{"total"}}; 
		if ($_ =~ m/^CurrentTime/) {$info{"current"} = $_; $info{"current"} =~ s/CurrentTime:[ ]*//; chomp $info{"current"}}; 
		if ($_ =~ m/^Bitrate:/) {$info{"bitrate"} = $_; $info{"bitrate"} =~ s/Bitrate: //; chomp $info{"bitrate"}}; 
		if ($_ =~ m/^Rate:/) {$info{"rate"} = $_; $info{"rate"} =~ s/Rate: //; chomp $info{"rate"}}; 
		if ($_ =~ m/^File: /) {
			$info{"file"} = $_;
			chomp($info{'file'});
			$info{"file"} =~ s/File: //;
			chomp $info{"file"};
			if ($info{"file"} =~ m/^http:\/\//){
				$in = 1;
			}

			$info{"type"} = `file \"$info{'file'}\"`;  #Dateityp
			my $tmp = -s $info{'file'};
			$info{"size"} = sprintf("%.2f MB", ((($tmp) / 1024) / 1024)) ;
		}
		
	}
	if ($info{'type'} =~ /mp3/i){
		$info{'type'} = "mp3";
	}
	elsif ($info{'type'} =~ /ogg/i){
		$info{'type'} = "ogg";
	}
	elsif ($info{'type'} =~ /wav/i){
		$info{'type'} = "wav";
	}
	else{ 
		$info{'type'} = "unknown";
	}

	$string = "moc is currently playing: $info{'artist'} - $info{'title'} on \"$info{'album'}\" | [$info{'current'}/$info{'total'}] " . 
			"| [$info{'bitrate'}] | [$info{'rate'}] | [$info{'size'}] | [$info{'type'}]" ;
	if ($in =~ 1){
		stream();
	}
	
}

sub stream{
	$string = "moc is currently playing: $info{'artist'} - $info{'title'} | [$info{'current'}] " . 
			"| [$info{'bitrate'}] | [$info{'rate'}] | [$info{'file'}] | [Streaming...]" ;
}



sub ctcp(){
	unless(checkplaying() == 1){
		moc();
		Irssi::settings_set_str('ctcp_version_reply', "$string");
	}
}

Irssi::signal_add('ctcp msg version', 'ctcp');


